﻿using Microsoft.Office.Interop.Outlook;
using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 커스텀 애드인
    /// </summary>
    public partial class CustomAddIn
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region 커스텀 애드인 시작시 처리하기 - CustomAddIn_Startup(sender, e)

        /// <summary>
        /// 커스텀 애드인 시작시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Startup(object sender, EventArgs e)
        {
            FindContactItem("Jo", "Berry");
        }

        #endregion
        #region 커스텀 애드인 셧다운시 처리하기 - CustomAddIn_Shutdown(sender, e)

        /// <summary>
        /// 커스텀 애드인 셧다운시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void CustomAddIn_Shutdown(object sender, EventArgs e)
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region VSTO에서 생성한 코드

        /// <summary>
        /// 디자이너 지원에 필요한 메서드입니다. 
        /// 이 메서드의 내용을 코드 편집기로 수정하지 마세요.
        /// </summary>
        private void InternalStartup()
        {
            this.Startup  += new System.EventHandler(CustomAddIn_Startup );
            this.Shutdown += new System.EventHandler(CustomAddIn_Shutdown);
        }

        #endregion

        #region 연락처 항목 찾기 - FindContactItem(firstName, lastName)

        /// <summary>
        /// 연락처 항목 찾기
        /// </summary>
        /// <param name="firstName">이름</param>
        /// <param name="lastName">성</param>
        private void FindContactItem(string firstName, string lastName)
        {
            NameSpace outlookNameSpace = Application.GetNamespace("MAPI");

            MAPIFolder contactsFolder = outlookNameSpace.GetDefaultFolder(OlDefaultFolders.olFolderContacts);

            Items contactsFolderItems = contactsFolder.Items;

            try
            {
                ContactItem contactItem = (ContactItem)contactsFolderItems.Find($"[FirstName]='{firstName}' and  [LastName]='{lastName}'");

                if(contactItem != null)
                {
                    contactItem.Display(true);
                }
                else
                {
                    MessageBox.Show("The contact information was not found.");
                }
            }
            catch(System.Exception exception)
            {
                throw exception;
            }
        }

        #endregion
    }
}